module Main(main,
 Natnum,
 recsum,itsum,
 lt,gt,eq,leq,geq, neq,
 recsub,itsub,
 recmult, itmult,mult,
 itmod,recdiv,
 nn2int,int2nn,natop)

where

import System(getArgs)
-- import Data.Bits
main = do args <- getArgs
          let
            m = read (args!!0)  --  number
            n = read (args!!1)  --  number
          putStrLn ((show m) ++ " + " ++ (show n) ++ " = " ++ show(recsum  m n))

data Natnum  = Z | S Natnum
	      deriving (Eq, Read, Show)

lt Z Z  = False
lt (S m) Z = False
lt Z (S n) = True
lt (S m) (S n) = lt m n

gt Z (S n) = False
gt Z Z  = False
gt (S m) Z = True
gt (S m) (S n) = gt m n

eq Z Z = True
eq (S m) Z = False
eq Z (S m) = False
eq (S m) (S n) = eq m n

leq m n = (lt m n) || (eq m n)

neq x = not . (eq x)

geq x = not . (lt x)

recsum  m Z = m
recsum  m (S n) = (S (recsum m n))

itsum m Z = m
itsum m (S n) = itsum (S m) n

recsub Z (S n) = error"recsub doesn't work for negative numbers"
recsub m Z = m
recsub m (S n) = u
	         where (S u) = recsub m n

itsub Z (S n) = error"itsub doesn't work for negative numbers"
itsub m Z = m
itsub (S m) (S n) = itsub m n 


recmult m Z = Z
recmult m (S n) = itsum(recmult m n) m

itmult m n = let 
               itmultacc m Z acc = acc
               itmultacc m (S n) acc = itmultacc m n (itsum acc m) 
             in itmultacc m n Z

mult Z n = Z
mult (S m) n = recsum(mult m n) n

itmod m n = if lt m n
            then m
            else itmod (itsub m n) n

recdiv m Z = error"division by zero"
recdiv m n = if lt m n
             then Z
             else S (recdiv (itsub m n) n)

nn2int Z = 0
nn2int (S n) = 1+(nn2int n)

int2nn 0 = Z
int2nn (n+1) = S(int2nn n)

natop op m n = nn2int(op (int2nn m) (int2nn n))
