module Quick where

import Test.QuickCheck

rev [] = []
rev (x:xs) = (rev xs) ++ [x]

prop_RevRev xs = rev (rev xs) == xs
  where types = xs::[Int]

prop_AbsurdRevId xs = rev xs == xs
  where types = xs::[Int]

linrev [] ys = ys
linrev (x:xs) ys = linrev xs (x:ys)

prop_LinrevRev xs = (rev xs) == (linrev xs [])
  where types = xs::[Int]

prop_LinRevLinRev xs ys = (linrev xs ys) == ((rev xs)++ys)
  where types = (xs,ys)::([Int],[Int])


cat [] ys = ys
cat (x:xs) ys = (x:(cat xs ys))

prop_CatRightID xs = (cat xs []) == xs
  where types = xs::[Int]

prop_CatAssoc xs ys zs = (cat xs (cat ys zs)) == (cat (cat xs ys) zs)
  where types = (xs::[Int], ys::[Int],zs::[Int])
