module IOTest where

import System.IO
import Data.Bits
import Data.IORef
import GHC.IOBase
import Control.Concurrent
import Random

nl = putChar '\n'

done:: IO ()
done = return ()

puts [] = done
puts (x:xs) = putChar x >> puts xs

rollDice :: IO Int
rollDice = getStdRandom (randomR (1,6))

aroll lb ub = (getStdRandom (randomR (lb,ub))):: IO Int

broll = (getStdRandom random):: IO Int


iog =  getStdGen >>= \g-> return (split g)

intrand pi iog = iog >>= \gpair -> print ((fst (random (pi gpair)))::Int)

sfork = forkIO (fstfrk 0) >> (sndfrk 1000)

fstfrk i | i == 1000 = return ()
         | i < 1000 = putStr "fst" >> print i >> fstfrk (i+1)

sndfrk i | i == 0 = return ()
         | i > 0 = putStr "snd" >> print i >> sndfrk (i-1)
  
