module Main where

import System.IO
import System.Environment

sieve (p:xs) = p:(sieve [x | x<- xs, x `mod` p /= 0])

primes = sieve [2..]

mlast [] = []
mlast [x] = [x]
mlast (x:xs) = mlast xs

main = getArgs >>= 
	\ args -> print args >>
		  if (args!!0) == "t" 
		  then getLine >>= \ ln -> print (take (read ln) primes)
		  else getLine >>= \ ln -> print (head (mlast (take (read ln) primes)))

